#ifndef  MERYRELAY2_H
#define  MERYRELAY2_H

#define  STRICT
#define  NOMINMAX
#define  WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <algorithm> // swap(C++03)

/*
	Relay  MeryA exe ̒lB
*/
class MeryRelay
{
public: // ^

	/*
		HANDLE z_[BfXgN^ CloseHandle ܂B
	*/
	class Handle
	{
	public:
		explicit Handle(HANDLE handle);
		         Handle(const Handle& other);
		Handle&  operator=(const Handle& self_or_other);
		        ~Handle();

		operator HANDLE() const;
		bool     Valid()  const;
		HANDLE   Release();
		void     Close();
	private:
		HANDLE   m_handle;
	};

	/*
		Mery Ƃ̂ȂB
	*/
	class Reply
	{
	public:
		explicit Reply(HANDLE hPipeServer);
		         Reply(const Reply& other);

		bool     Accepted()           const;
		void     GoTogetherUntilEnd() const;
	private:
		Handle   m_handle;
	};

	/*
		OȂBC^CCusvB
		T ̃RXgN^ƂfXgN^ƂAĂт܂B
	*/
	template<class T>
	class Array
	{
	public:
		         Array();
		explicit Array(size_t size);
		void     Dispose();

		         operator T*();
		T*       Begin() const;
		T*       End()   const;
		size_t   Size()  const;

		MeryRelay::Array<T>&
		         Resize(size_t size);
	private:
		         Array(const Array& other); // `Ȃ
		Array&   operator=(const Array& self_or_other); // `Ȃ

		T*       m_array;
		T*       m_array_end; // l m_array Ɉˑ̂Ő錾厖B
	};

public:
	explicit   MeryRelay(const wchar_t* pszName);

	Handle     Accept()  const;
	Reply      Propose() const;
private:
	           MeryRelay(const MeryRelay& other); // ʓ|`Ȃ
	MeryRelay& operator=(const MeryRelay& self_or_other); // ʓ|`Ȃ

	wchar_t    m_szName[32]; // pCvB~[ebNXB
};

/*
	class MeryRelay::Handle
*/

inline
MeryRelay::Handle::
Handle(HANDLE handle)
: m_handle(handle)
{}

inline
MeryRelay::Handle::
Handle(const Handle& other)
: m_handle(other.m_handle)
{
/*
	[uRXgN^ł DuplicateHandle Ȃ̂낤B
	pair AReiɓAReiōĔzuNA
	ׂĂŃnh̕CB
*/
	if (! this->Valid()) {
		return;
	}
	const HANDLE hProcess = GetCurrentProcess();
	if (0 == DuplicateHandle(hProcess,  m_handle,
	                         hProcess, &m_handle,
	                         0, FALSE, DUPLICATE_SAME_ACCESS)
	) {
		m_handle = INVALID_HANDLE_VALUE;
		return;
	}
}

inline MeryRelay::Handle&
MeryRelay::Handle::
operator=(const Handle& self_or_other)
{
	Handle t(self_or_other);
	std::swap(m_handle, t.m_handle);
	return *this;
}

inline
MeryRelay::Handle::
~Handle()
{
	CloseHandle(m_handle);
}

inline
MeryRelay::Handle::
operator HANDLE() const
{
	return m_handle;
}

inline bool
MeryRelay::Handle::
Valid() const
{
	return m_handle != INVALID_HANDLE_VALUE
	    && m_handle != NULL;
}

inline HANDLE
MeryRelay::Handle::
Release()
{
	HANDLE h = m_handle;
	m_handle = INVALID_HANDLE_VALUE;
	return h;
}

inline void
MeryRelay::Handle::
Close()
{
	CloseHandle(m_handle);
	m_handle = INVALID_HANDLE_VALUE;
}

/*
	class MeryRelay::Reply
*/

inline
MeryRelay::Reply::
Reply(HANDLE hPipeServer)
: m_handle(hPipeServer)
{
}

inline
MeryRelay::Reply::
Reply(const Reply& other)
: m_handle(other.m_handle)
{
}

inline bool
MeryRelay::Reply::
Accepted() const
{
	return m_handle.Valid();
}

inline void
MeryRelay::Reply::
GoTogetherUntilEnd() const
{
	if (! m_handle.Valid()) {
		return;
	}
	wchar_t buf[4]; DWORD unused; OVERLAPPED ol;
	ol.Internal = ol.InternalHigh = NULL; ol.Pointer = NULL;
	ol.hEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
	if (ol.hEvent == NULL) {
		return;
	}
	Handle Closer(ol.hEvent);
	ReadFile(m_handle, buf, sizeof(buf), &unused, &ol); // &ol  NULL ɂ邾łIɑ҂Ă(葼Ȃ)݂ǁAhLgɂȂB
	if (GetLastError() == ERROR_IO_PENDING) {
		GetOverlappedResult(m_handle, &ol, &unused, TRUE);
	}
}

/*
	class MeryRelay::Array<T>
*/

template<typename T> inline
MeryRelay::Array<T>::
Array()
: m_array(0)
, m_array_end(m_array)
{
}

template<typename T> inline
MeryRelay::Array<T>::
Array(size_t size)
: m_array(0)
, m_array_end(m_array)
{
	Resize(size);
}

template<typename T> inline
void
MeryRelay::Array<T>::
Dispose()
{
	Resize(0);
}

template<typename T> inline
MeryRelay::Array<T>::
operator T*()
{
	return m_array;
}

template<typename T> inline
T*
MeryRelay::Array<T>::
Begin() const
{
	return m_array;
}

template<typename T> inline
T*
MeryRelay::Array<T>::
End() const
{
	return m_array_end;
}

template<typename T> inline
size_t
MeryRelay::Array<T>::
Size() const
{
	return m_array_end - m_array;
}

template<typename T> inline
MeryRelay::Array<T>&
MeryRelay::Array<T>::
Resize(size_t size)
{
	if (size == m_array_end - m_array) {
		return *this;
	}

	const HANDLE ProcessHeap = GetProcessHeap(); // CloseHandle ɂăhLgɏĂȂTvɂȂB݃\[XĂƂB
	if (size == 0) { // L疳
		HeapFree(ProcessHeap, 0, m_array);
		m_array = 0;
	} else if (m_array == m_array_end) { // L
		m_array = (T*)HeapAlloc(ProcessHeap, HEAP_ZERO_MEMORY, sizeof(T) * size);
	} else { // LL
		LPVOID p = HeapReAlloc(ProcessHeap, HEAP_ZERO_MEMORY, m_array, sizeof(T) * size);
		m_array = p ? (T*)p : m_array;
	}
	m_array_end = m_array + (m_array ? HeapSize(ProcessHeap, 0, m_array)/sizeof(T) : 0);
	return *this;
}

/*
	class MeryRelay
*/

inline
MeryRelay::
MeryRelay(const wchar_t* pszName)
{
	const wchar_t* pszTexts[] = {L"\\\\.\\pipe\\", pszName};
	/* ȍ~͗v
		wcscpy_s(m_szName, pszTexts[0]);
		wcscat_s(m_szName, pszTexts[1]);
	*/
	const wchar_t **ppszText = pszTexts, **ppszTextEnd = pszTexts + sizeof(pszTexts)/sizeof(pszTexts[0]);
	      wchar_t  *dst      = m_szName,  *dstEnd      = m_szName + sizeof(m_szName)/sizeof(m_szName[0]) - 1; // 1 is reserved for L'\0'
	for (; ppszText != ppszTextEnd; ++ppszText) {
		int i = 0;
		for (; dst + i < dstEnd; ++i) {
			if (! (dst[i] = (*ppszText)[i])) {
				break;
			}
		}
		dst += i;
	}
	*dstEnd = L'\0';
}

inline
MeryRelay::Handle
MeryRelay::
Accept() const
{
	HANDLE hPipe = CreateFile(
		m_szName,
		GENERIC_WRITE,
		0,                    // no sharing 
		NULL,                 // default security attributes
		OPEN_EXISTING,        // opens existing pipe 
		FILE_FLAG_OVERLAPPED, // attributes 
		NULL                  // no template file 
	);
	return Handle(hPipe);
}

template<size_t Size> static inline
const wchar_t*
GetMeryPathBesideMe(wchar_t (&szPath)[Size])
{
	if (Size == 0) {
		return szPath;
	}
	szPath[0] = L'\0';
	GetModuleFileNameW(NULL, szPath, Size);
	szPath[Size-1] = L'\0';
	int iFile = 0;
	for (int i = 0; i < Size; ++i) {
		if (szPath[i] == L'\0') {
			break;
		}
		if (szPath[i] == L'\\') {
			iFile = i+1;
		}
	}
	for (int i = iFile; i < Size-1; ++i) {
		if (L'\0' == (szPath[i] = L"Mery.exe"[i-iFile])) {
			break;
		}
	}
	return szPath;
}

inline
MeryRelay::Reply
MeryRelay::
Propose() const
{
	class OwnedMutex
	{
	public:
		explicit OwnedMutex(const wchar_t* pszName)
		: m_handle(CreateMutex(NULL, FALSE, pszName))
		{
			if (m_handle != NULL) {
				WaitForSingleObject(m_handle, INFINITE);
			}
		}
		~OwnedMutex()
		{
			if (m_handle != NULL) {
				ReleaseMutex(m_handle);
				CloseHandle(m_handle);
			}
		}
	private:
		HANDLE m_handle;
	} MeryRelay2Mutex(m_szName + sizeof(L"\\\\.\\pipe\\")/sizeof(wchar_t) -1);
	// Mutex ̎擾ɎsĂĂЂǂƂɂ͂ȂȂB

	HANDLE hPipe = CreateNamedPipe(
		m_szName,
		PIPE_ACCESS_INBOUND | FILE_FLAG_OVERLAPPED,
		PIPE_TYPE_BYTE | PIPE_READMODE_BYTE | PIPE_WAIT,
		PIPE_UNLIMITED_INSTANCES,
		2,
		2,
		100,
		NULL
	);
	MeryRelay::Reply succeeded(hPipe); // closer ˂ĂB
	MeryRelay::Reply failed(INVALID_HANDLE_VALUE);

	if (hPipe == INVALID_HANDLE_VALUE) {
		return failed;
	}
	OVERLAPPED ol; ol.Internal = ol.InternalHigh = NULL; ol.Pointer = NULL;
	ol.hEvent = CreateEvent(NULL, TRUE, TRUE, NULL);
	if (ol.hEvent == NULL) {
		return failed;
	}
	Handle Closer1(ol.hEvent);
	if (0 != ConnectNamedPipe(hPipe, &ol)) {
		return failed; // Overlapped ConnectNamedPipe should return zero.
	}
	switch(GetLastError())
	{
	case ERROR_IO_PENDING:
	case ERROR_PIPE_LISTENING: // ꂪB
		break;

	case ERROR_PIPE_CONNECTED: // łɐڑĂB(͒NH)
	case ERROR_NO_DATA:        // łɐڑĐؒfĂB(͒NH)
	default:
		SetEvent(ol.hEvent);
		break;
	}
/*
	Ԏ҂ĂԎׂ Mery NsvcB
*/
	wchar_t szMeryPath[_MAX_PATH]; szMeryPath[0] = L'\0';
	GetMeryPathBesideMe(szMeryPath);
	PROCESS_INFORMATION pi; pi.hProcess = pi.hThread = INVALID_HANDLE_VALUE;
	STARTUPINFO si; GetStartupInfo(&si);
	si.lpReserved = si.lpDesktop = si.lpTitle = NULL;
	si.dwFlags = STARTF_USESHOWWINDOW;
	si.cbReserved2 = 0; si.lpReserved = NULL;
	if (0 == CreateProcess(
		szMeryPath,
		GetCommandLine(),
		NULL,
		NULL,
		FALSE,
		0,
		NULL,
		NULL,
		&si,
		&pi
	)) {
		return failed;
	}
	Handle Closer2(pi.hProcess), Closer3(pi.hThread);
/*
	Mery ̕Ԏ҂B
*/
	const HANDLE handles[] = {pi.hProcess, ol.hEvent};
	DWORD signaled = WaitForMultipleObjects(sizeof(handles)/sizeof(handles[0]), handles, FALSE, INFINITE);
	if (signaled == WAIT_OBJECT_0) { // ]
	/*
		ڋN Mery ͎񂾂ȂAłɋNĂ
		Mery vZXOサĕԎԂȂ̂ŁAƑ҂B
	*/
		WaitForSingleObject(ol.hEvent, 100);
	}
	DWORD unused;
	if (0 == GetOverlappedResult(hPipe, &ol, &unused, FALSE)
	   || ! HasOverlappedIoCompleted(&ol)
	) {
	/*
		ɗ̂ Mery ȂBׂvOC
		LłȂAłɊJĂĂȂANeBuȃt@C
		xJƂRBOnEvent(EVENT_DOC_SEL_CHANGED) ŕߑł
		̂Vt@CJƂƁAVJƂƁAł
		JĂt@CJƂă^uANeBuɂȂƂȂ̂ŁB
	*/
		return failed;
	}

	return succeeded;
}

#endif MERYRELAY2_H
